<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>MBeanRegistry.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.jmx</a> &gt; <span class="el_source">MBeanRegistry.java</span></div><h1>MBeanRegistry.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.jmx;

import java.lang.management.ManagementFactory;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.management.JMException;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class provides a unified interface for registering/unregistering of
 * zookeeper MBeans with the platform MBean server. It builds a hierarchy of MBeans
 * where each MBean represented by a filesystem-like path. Eventually, this hierarchy
 * will be stored in the zookeeper data tree instance as a virtual data tree.
 */
<span class="pc bpc" id="L40" title="1 of 2 branches missed.">public class MBeanRegistry {</span>
<span class="fc" id="L41">    private static final Logger LOG = LoggerFactory.getLogger(MBeanRegistry.class);</span>
    
<span class="fc" id="L43">    private static volatile MBeanRegistry instance = new MBeanRegistry();</span>
    
<span class="fc" id="L45">    private Map&lt;ZKMBeanInfo, String&gt; mapBean2Path =</span>
        new ConcurrentHashMap&lt;ZKMBeanInfo, String&gt;();
    
<span class="fc" id="L48">    private Map&lt;String, ZKMBeanInfo&gt; mapName2Bean =</span>
        new ConcurrentHashMap&lt;String, ZKMBeanInfo&gt;();

    private MBeanServer mBeanServer;

    public static void setInstance(MBeanRegistry instance) {
<span class="nc" id="L54">        MBeanRegistry.instance = instance;</span>
<span class="nc" id="L55">    }</span>

    public static MBeanRegistry getInstance() {
<span class="fc" id="L58">        return instance;</span>
    }

<span class="fc" id="L61">    public MBeanRegistry () {</span>
        try {
<span class="fc" id="L63">            mBeanServer = ManagementFactory.getPlatformMBeanServer();        </span>
<span class="nc" id="L64">        } catch (Error e) {</span>
            // Account for running within IKVM and create a new MBeanServer
            // if the PlatformMBeanServer does not exist.
<span class="nc" id="L67">            mBeanServer =  MBeanServerFactory.createMBeanServer();</span>
<span class="fc" id="L68">        }</span>
<span class="fc" id="L69">    }</span>

    /**
     * Return the underlying MBeanServer that is being
     * used to register MBean's. The returned MBeanServer
     * may be a new empty MBeanServer if running through IKVM.
     */
    public MBeanServer getPlatformMBeanServer() {
<span class="fc" id="L77">        return mBeanServer;</span>
    }

    /**
     * Registers a new MBean with the platform MBean server. 
     * @param bean the bean being registered
     * @param parent if not null, the new bean will be registered as a child
     * node of this parent.
     */
    public void register(ZKMBeanInfo bean, ZKMBeanInfo parent)
        throws JMException
    {
<span class="pc bpc" id="L89" title="3 of 4 branches missed.">        assert bean != null;</span>
<span class="fc" id="L90">        String path = null;</span>
<span class="fc bfc" id="L91" title="All 2 branches covered.">        if (parent != null) {</span>
<span class="fc" id="L92">            path = mapBean2Path.get(parent);</span>
<span class="pc bpc" id="L93" title="3 of 4 branches missed.">            assert path != null;</span>
        }
<span class="fc" id="L95">        path = makeFullPath(path, parent);</span>
<span class="pc bpc" id="L96" title="1 of 2 branches missed.">        if(bean.isHidden())</span>
<span class="nc" id="L97">            return;</span>
<span class="fc" id="L98">        ObjectName oname = makeObjectName(path, bean);</span>
        try {
<span class="fc" id="L100">            mBeanServer.registerMBean(bean, oname);</span>
<span class="fc" id="L101">            mapBean2Path.put(bean, path);</span>
<span class="fc" id="L102">            mapName2Bean.put(bean.getName(), bean);</span>
<span class="fc" id="L103">        } catch (JMException e) {</span>
<span class="fc" id="L104">            LOG.warn(&quot;Failed to register MBean &quot; + bean.getName());</span>
<span class="fc" id="L105">            throw e;</span>
<span class="fc" id="L106">        }</span>
<span class="fc" id="L107">    }</span>

    /**
     * Unregister the MBean identified by the path.
     * @param path
     * @param bean
     */
    private void unregister(String path,ZKMBeanInfo bean) throws JMException {
<span class="fc bfc" id="L115" title="All 2 branches covered.">        if(path==null)</span>
<span class="fc" id="L116">            return;</span>
<span class="pc bpc" id="L117" title="1 of 2 branches missed.">        if (!bean.isHidden()) {</span>
            try {
<span class="fc" id="L119">                mBeanServer.unregisterMBean(makeObjectName(path, bean));</span>
<span class="fc" id="L120">            } catch (JMException e) {</span>
<span class="fc" id="L121">                LOG.warn(&quot;Failed to unregister MBean &quot; + bean.getName());</span>
<span class="fc" id="L122">                throw e;</span>
<span class="fc" id="L123">            }</span>
        }        
<span class="fc" id="L125">    }</span>
    
    /**
     * Unregister MBean.
     * @param bean
     */
    public void unregister(ZKMBeanInfo bean) {
<span class="pc bpc" id="L132" title="1 of 2 branches missed.">        if(bean==null)</span>
<span class="nc" id="L133">            return;</span>
<span class="fc" id="L134">        String path=mapBean2Path.get(bean);</span>
        try {
<span class="fc" id="L136">            unregister(path,bean);</span>
<span class="fc" id="L137">        } catch (JMException e) {</span>
<span class="fc" id="L138">            LOG.warn(&quot;Error during unregister&quot;, e);</span>
<span class="fc" id="L139">        }</span>
<span class="fc" id="L140">        mapBean2Path.remove(bean);</span>
<span class="fc" id="L141">        mapName2Bean.remove(bean.getName());</span>
<span class="fc" id="L142">    }</span>
    /**
     * Unregister all currently registered MBeans
     */
    public void unregisterAll() {
<span class="fc bfc" id="L147" title="All 2 branches covered.">        for(Map.Entry&lt;ZKMBeanInfo,String&gt; e: mapBean2Path.entrySet()) {</span>
            try {
<span class="fc" id="L149">                unregister(e.getValue(), e.getKey());</span>
<span class="fc" id="L150">            } catch (JMException e1) {</span>
<span class="fc" id="L151">                LOG.warn(&quot;Error during unregister&quot;, e1);</span>
<span class="fc" id="L152">            }</span>
<span class="fc" id="L153">        }</span>
<span class="fc" id="L154">        mapBean2Path.clear();</span>
<span class="fc" id="L155">        mapName2Bean.clear();</span>
<span class="fc" id="L156">    }</span>
    /**
     * Generate a filesystem-like path.
     * @param prefix path prefix
     * @param name path elements
     * @return absolute path
     */
    public String makeFullPath(String prefix, String... name) {
<span class="fc bfc" id="L164" title="All 4 branches covered.">        StringBuilder sb=new StringBuilder(prefix == null ? &quot;/&quot; : (prefix.equals(&quot;/&quot;)?prefix:prefix+&quot;/&quot;));</span>
<span class="fc" id="L165">        boolean first=true;</span>
<span class="fc bfc" id="L166" title="All 2 branches covered.">        for (String s : name) {</span>
<span class="fc bfc" id="L167" title="All 2 branches covered.">            if(s==null) continue;</span>
<span class="fc bfc" id="L168" title="All 2 branches covered.">            if(!first){</span>
<span class="fc" id="L169">                sb.append(&quot;/&quot;);</span>
            }else
<span class="fc" id="L171">                first=false;</span>
<span class="fc" id="L172">            sb.append(s);</span>
        }
<span class="fc" id="L174">        return sb.toString();</span>
    }
    
    protected String makeFullPath(String prefix, ZKMBeanInfo bean) {
<span class="fc bfc" id="L178" title="All 2 branches covered.">        return makeFullPath(prefix, bean == null ? null : bean.getName());</span>
    }

    /**
     * This takes a path, such as /a/b/c, and converts it to 
     * name0=a,name1=b,name2=c
     */
    private int tokenize(StringBuilder sb, String path, int index){
<span class="fc" id="L186">        String[] tokens = path.split(&quot;/&quot;);</span>
<span class="fc bfc" id="L187" title="All 2 branches covered.">        for (String s: tokens) {</span>
<span class="fc bfc" id="L188" title="All 2 branches covered.">            if (s.length()==0)</span>
<span class="fc" id="L189">                continue;</span>
<span class="fc" id="L190">            sb.append(&quot;name&quot;).append(index++)</span>
<span class="fc" id="L191">                    .append(&quot;=&quot;).append(s).append(&quot;,&quot;);</span>
        }
<span class="fc" id="L193">        return index;</span>
    }
    /**
     * Builds an MBean path and creates an ObjectName instance using the path. 
     * @param path MBean path
     * @param bean the MBean instance
     * @return ObjectName to be registered with the platform MBean server
     */
    protected ObjectName makeObjectName(String path, ZKMBeanInfo bean)
        throws MalformedObjectNameException
    {
<span class="pc bpc" id="L204" title="1 of 2 branches missed.">        if(path==null)</span>
<span class="nc" id="L205">            return null;</span>
<span class="fc" id="L206">        StringBuilder beanName = new StringBuilder(CommonNames.DOMAIN + &quot;:&quot;);</span>
<span class="fc" id="L207">        int counter=0;</span>
<span class="fc" id="L208">        counter=tokenize(beanName,path,counter);</span>
<span class="fc" id="L209">        tokenize(beanName,bean.getName(),counter);</span>
<span class="fc" id="L210">        beanName.deleteCharAt(beanName.length()-1);</span>
        try {
<span class="fc" id="L212">            return new ObjectName(beanName.toString());</span>
<span class="nc" id="L213">        } catch (MalformedObjectNameException e) {</span>
<span class="nc" id="L214">            LOG.warn(&quot;Invalid name \&quot;&quot; + beanName.toString() + &quot;\&quot; for class &quot;</span>
<span class="nc" id="L215">                    + bean.getClass().toString());</span>
<span class="nc" id="L216">            throw e;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>